
#include <InMemoryBuffer.h>

#include "ItemType.h"
#include "Registries.h"

ItemType::ItemType(int id, ModelInfo model)
	: ReferenceCounter(),
	id(id),
	model(model)
{}

ItemType::~ItemType()
{}

int ItemType::getId() const
{
	return id;
}

Framework::Model3DData* ItemType::getItemModel() const
{
	return model.getModel();
}

Framework::Model3DTextur* ItemType::getItemTextur() const
{
	return model.getTexture();
}